// ---------------------------------------------------------------------------
//
// frmMain(easyStanz.PAS/DFM)                            Ulrich Mller 28.2.02
//                                                       Procida 400NT Delphi4
// Stanzmaschine mit Transportband (51 663)
// mit FishFa50.DCU v5.1 auf Basis von umFish20.DLL
//
// ---------------------------------------------------------------------------

unit easyStanz;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FishFa50;

type
  TfrmMain = class(TForm)
    cmdAction: TButton;
    cmdEnde: TButton;
    cboPortName: TComboBox;
    lblStatus: TLabel;
    procedure cmdEndeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Action();
    procedure cmdActionClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation
{$R *.DFM}

const
  mBand   = 1;
  cbVor   = ftiLinks;
  cbRuck  = ftiRechts;
  ePhotoV = 1;
  ePhotoS = 2;
  mLampen = 3;

  mStanze = 2;
  eOben   = 3;
  eUnten  = 4;
  csAb    = ftiLinks;
  csAuf   = ftiRechts;

var
  ft: TFishFace;


procedure TfrmMain.Action();
// --- Routine fr den Modellbetrieb, kann weitere procedures aufrufen ---
begin
  ft.ClearMotors;
  ft.SetMotor(mStanze, csAuf);
  ft.WaitForInput(eOben);
  ft.SetMotor(mStanze, ftiAus);
  ft.SetMotor(mLampen, ftiEin);
  repeat
    lblStatus.Caption := 'Wartet';
    ft.WaitForLow(ePhotoV);
    ft.Pause(500);

    lblStatus.Caption := 'Zur Stanze';
    ft.SetMotor(mBand, cbVor);
    ft.WaitForLow(ePhotoS);
    ft.SetMotor(mBand, ftiAus);

    lblStatus.Caption := 'Stanzen';
    ft.SetMotor(mStanze, csAb);
    ft.WaitForInput(eUnten);
    ft.SetMotor(mStanze, ftiAus);
    ft.Pause(1000);
    ft.SetMotor(mStanze, csAuf);
    ft.WaitForInput(eOben);
    ft.SetMotor(mStanze, ftiAus);

    lblStatus.Caption := 'Zurck';
    ft.SetMotor(mBand, cbRuck);
    ft.WaitForInput(ePhotoV, false);
    ft.Pause(300);
    ft.SetMotor(mBand, ftiAus);
  until ft.Finish(0);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  ft := TFishFace.Create;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ft.Free;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
// --- Programmende sperren, wenn noch Modellbetrieb ------
begin
  if cmdEnde.Caption = '&HALT' then CanClose := false;
end;

procedure TfrmMain.cmdActionClick(Sender: TObject);
// --- Steuern des Modellbetriebes --------------------
begin
  if ft.OpenInterface(cboPortName.Text) = ftiFehler then begin
    MessageDlg('InterfaceProblem', mtInformation, [mbOK], 0);
    exit;
    end;
  cmdAction.Enabled := false;
  cmdEnde.Caption   := '&HALT';
  lblStatus.Caption := 'luft';
  cmdEnde.SetFocus;

  Action;

  ft.ClearMotors;
  ft.CloseInterface;
  cmdAction.Enabled := true;
  cmdEnde.Caption   := '&ENDE';
  lblStatus.Caption := 'START/ENDE';
end;

procedure TfrmMain.cmdEndeClick(Sender: TObject);
// --- Beenden des Modellbetriebs, wenn HALT-Button, sonst Programmende ---
begin
  if cmdEnde.Caption = '&HALT' then ft.NotHalt := true else Self.Close;
end;

end.
